using System;
using System.Collections.Generic;
using System.Windows.Forms;
using LighthouseShared;
using System.IO;

namespace Lighthouse
{
    static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
#if DEBUG
            FileStream fs = new FileStream(args[0] + @"\settings.xml", FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.Read);
            Application.Run(new FormMain(args[0], fs));
#else
            Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(Application_ThreadException);

            try
            {
                FileStream fs = new FileStream(args[0] + @"\settings.xml", FileMode.OpenOrCreate, FileAccess.ReadWrite, FileShare.Read);
                Application.Run(new FormMain(args[0], fs));
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Lighthouse Error");
                Environment.Exit(2);
            }
#endif
        }

        static void Application_ThreadException(object sender, System.Threading.ThreadExceptionEventArgs e)
        {
            File.AppendAllText(Directory.GetCurrentDirectory() + @"\errorlog.txt", String.Format("Fatal exception at {0} {1}: {2}: {3}\r\n{4}\r\n\r\n", DateTime.Now.ToLongDateString(), DateTime.Now.ToLongTimeString(), e.Exception.GetType().Name, e.Exception.Message, e.Exception.StackTrace));
            Environment.Exit(1);
        }
    }
}