using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Xml;
using LighthouseShared;
using System.Threading;
using System.Diagnostics;

namespace LighthouseLauncher
{
    public partial class FormStartup : Form
    {
        public string cwd;

        public static Exception RunForm()
        {
            try 
            {
                Application.Run(new FormStartup());
            }
            catch (Exception ex)
            {
                return ex;
            }

            return null;
        }

        public FormStartup()
        {
            InitializeComponent();

            try
            {
                cwd = Directory.GetCurrentDirectory();

                foreach (string s in Directory.GetDirectories(cwd + @"\Profiles"))
                {
                    if (File.Exists(s + @"\settings.xml"))
                    {
                        listBox1.Items.Add(s.Substring(s.LastIndexOf('\\') + 1));
                    }
                }

                listBox1.SelectedIndex = 0;
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                if (listBox1.Items.Count < 1)

                {
                    radioButton2.Enabled = false;
                    radioButton3.Enabled = false;
                }
                else
                {
                    radioButton2.Checked = true;
                }

                radioButton1_CheckedChanged(null, null);
            }
        }

        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {

            if (radioButton1.Checked)
            {
                string newprofile = cwd + @"\Profiles\" + textBox1.Text;

                if (Directory.Exists(newprofile))
                {
                    MessageBox.Show("Profile already exists!", "Error");
                }
                else
                {
                    try
                    {
                        Directory.CreateDirectory(newprofile);

                        ChooseProfile(newprofile);
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("Unable to create profile: " + ex.Message, "Error");
                    }
                }
            }
            else if (radioButton2.Checked)
            {
                string profile = cwd + @"\Profiles\" + listBox1.SelectedItem.ToString();

                try
                {
                    ChooseProfile(profile);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Unable to open profile: " + ex.Message, "Error");
                }
            }
            else if (radioButton3.Checked)
            {
                string oldprofile = cwd + @"\Profiles\" + listBox1.SelectedItem.ToString();
                string newprofile = cwd + @"\Profiles\" + textBox1.Text;

                try
                {
                    Directory.CreateDirectory(newprofile);

                    foreach (string s in Directory.GetFiles(oldprofile, "*", SearchOption.AllDirectories))
                    {
                        File.Copy(s, s.Replace(oldprofile, newprofile));
                    }

                    ChooseProfile(newprofile);
                }
                catch (Exception ex)
                {
                    MessageBox.Show("Unable to clone profile: " + ex.Message, "Error");
                    try
                    {
                        Directory.Delete(newprofile, true);
                    }
                    catch (Exception ex2)
                    {
                    }
                }
            }
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (radioButton1.Checked)
            {
                listBox1.Enabled = false;
                textBox1.Enabled = true;
            }
            else if (radioButton2.Checked)
            {
                listBox1.Enabled = true;
                textBox1.Enabled = false;
            }
            else if (radioButton3.Checked)
            {
                listBox1.Enabled = true;
                textBox1.Enabled = true;
            }
        }

        private void ChooseProfile(string profile)
        {
            Process lighthouse = new Process();
            lighthouse.StartInfo = new ProcessStartInfo(Directory.GetCurrentDirectory() + @"\Lighthouse.exe", "\"" + profile + "\"");

            this.WindowState = FormWindowState.Minimized;
            this.Hide();

            while (true) // i would call any other programmer an idiot for doing this, but i have a good reason!! honest!!
            {
                lighthouse.Start();
                lighthouse.WaitForExit();

                if (lighthouse.ExitCode == 0)
                {
                    Environment.Exit(0);
                }
                else if (lighthouse.ExitCode == 1)
                {
                    continue; //what is the point of this even being here?
                }
                else if (lighthouse.ExitCode == 2)
                {
                    this.WindowState = FormWindowState.Normal;
                    this.Show();
                    break;
                }
            }
        }

    }
}