using System;
using System.Collections.Generic;
using System.Text;
using LighthouseShared;
using System.Threading;

namespace Oscar5Plugin
{
    class ChatInfo : IChatInfo
    {
        internal FLAPSocket Socket;

        internal Dictionary<uint, BanInfo> m_PendingBans = new Dictionary<uint,BanInfo>();
        internal Dictionary<uint, BanInfo> m_PendingUnbans = new Dictionary<uint,BanInfo>();

        internal Timer m_BanTimer;
        internal bool m_BanTimer_Enabled = false;
        internal Timer m_UnbanTimer;
        internal bool m_UnbanTimer_Enabled = false;

        internal Oscar5 m_Oscar5;

        internal string m_Name;
        internal ushort m_Exchange;
        internal string m_DisplayName;
        internal ushort m_MaxMessageLength;
        internal string m_FullName;
        internal ushort m_Instance;
        internal string m_Owner;
        internal bool m_OwnershipAquired;

        public ChatInfo(Oscar5 oscar5, string name, ushort exchange)
        {
            m_Name = name;
            m_Exchange = exchange;
            m_Oscar5 = oscar5;
        }


    

        #region IClientChatInfo Members

        public string DisplayName
        {
            get { return m_DisplayName; }
        }
        public ushort MaxMessageLength
        {
            get { return m_MaxMessageLength; }
        }
        public string FullName
        {
            get { return m_FullName; }
        }
        public ushort Instance
        {
            get { return m_Instance; }
        }

        public string Name
        {
            get { return m_Name; }
        }

        public ushort Exchange
        {
            get { return m_Exchange; }
        }

        public string Owner
        {
            get { return m_Owner; }
        }

        public bool OwnershipAquired
        {
            get { return m_OwnershipAquired; }
        }

        #endregion
    }
}
