using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using LighthouseShared;

namespace Uccom3ishParser
{
    public partial class PanelOps : LighthouseShared.LHPanel
    {
        private SimpleCCOM m_CCOMPlugin;

        public PanelOps(SimpleCCOM ccomplugin)
        {
            m_CCOMPlugin = ccomplugin;

            this.PanelName = "Ops";

            InitializeComponent();
        }

        public override void UpdateUI()
        {
            base.UpdateUI();

            listBox1.Items.Clear();

            foreach (KeyValuePair<string, IUserInfo> u in m_CCOMPlugin.m_Users)
            {
                if (u.Value.Op)
                    listBox1.Items.Add(new ListItem(u.Value.ScreenName, u.Value));
            }

            checkedListBox2.Items.Clear();
            foreach (ICommandInfo c in m_CCOMPlugin.m_Commands)
            {
                checkedListBox2.Items.Add(new ListItem(c.Command, c));
            }
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                IUserInfo userinfo = (IUserInfo)((ListItem)listBox1.SelectedItem).Tag;

                for (int i = 0; i < checkedListBox2.Items.Count; i++)
                {
                    ICommandInfo commandinfo = (ICommandInfo)((ListItem)checkedListBox2.Items[i]).Tag;


                    if (userinfo.Permissions.Contains(commandinfo))
                        checkedListBox2.SetItemChecked(i, true);
                    else
                        checkedListBox2.SetItemChecked(i, false);

                }
            }
            catch (Exception)
            {
            }
        }

        private void checkedListBox2_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            if (listBox1.SelectedItem != null)
            {
                IUserInfo userinfo = (IUserInfo)((ListItem)listBox1.SelectedItem).Tag;

                ICommandInfo commandinfo = (ICommandInfo)((ListItem)checkedListBox2.Items[e.Index]).Tag;

                try
                {
                    if (e.NewValue == CheckState.Checked && !userinfo.Permissions.Contains(commandinfo))
                        userinfo.Permissions.Add(commandinfo);
                    else if (e.NewValue == CheckState.Unchecked)
                        userinfo.Permissions.Remove(commandinfo);
                }
                catch (Exception)
                {
                }
            }
        }

        private void checkedListBox2_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void textBoxAddOp_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                m_CCOMPlugin.CCOMAddOp(textBoxAddOp.Text);
                textBoxAddOp.Text = string.Empty;
                UpdateUI();
                textBoxAddOp.Focus();
            }
        }

        private void textBoxAddOp_TextChanged(object sender, EventArgs e)
        {

        }

        private void buttonDefaultPerms_Click(object sender, EventArgs e)
        {
            FormDefaultPerms f = new FormDefaultPerms(m_CCOMPlugin);
            f.ShowDialog();
        }

        private void listBox1_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Right)
            {
                Point p = new Point(e.X, e.Y);
                listBox1.SelectedIndex = listBox1.IndexFromPoint(p);
            }
        }

        private void removeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (listBox1.SelectedItem != null)
            {
                m_CCOMPlugin.CCOMRemoveOp(listBox1.SelectedItem.ToString());
                UpdateUI();
            }
        }


        
    }
}

